<template>
  <div class="row m-0 vh-100 justify-content-center align-items-center">
    <div class="col-auto p-5">
      <div class="card">
        <h1 class="card-header text-center">Heroes App</h1>
        <div class="card-body">
          <p>¿Olvidaste tu contraseña? Aquí puede recuperarla fácilmente.</p>
          <p v-if="errorMessage" class="text-danger">{{errorMessage}}</p>
          <form @submit.prevent="procesar" autocomplete="off">
            <div class="mb-3">
              <div class="input-group">
                <input type="email" class="form-control" :class="{'is-valid': !$v.email.$invalid, 'is-invalid': $v.email.$invalid}" placeholder="Correo electrónico" v-model="$v.email.$model" @keypress="limpiarErrores('email')">
                <div class="input-group-append">
                  <div class="input-group-text">
                    <span class="fas fa-envelope"></span>
                  </div>
                </div>
              </div>
              <div class="text-danger" v-if="!$v.email.required">
                El campo es requerido.
              </div>
              <div class="text-danger" v-if="!$v.email.email">
                El campo debe ser una dirección de correo válida.
              </div>
              <div class="text-danger" v-for="(errorEmail, index) in errors.email" :key="index">
                {{ errorEmail }}
              </div>
            </div>
            <button type="submit" :disabled="$v.$invalid || loading" class="btn btn-block btn-primary"><i v-if="loading" class="fas fa-spinner fa-pulse"></i> Cambio de contraseña</button>
          </form>
          <div class="mt-3 mb-1 d-flex justify-content-between">
            <routerLink :to="{name: 'Login'}">Iniciar sesion</routerLink>
            <routerLink :to="{name: 'Recovery'}">Ingresar codigo</routerLink>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { required, email } from 'vuelidate/lib/validators';

export default {
  data() {
    return {
      email: '',
      loading: false,
      errorMessage: '',
      errors: []
    }
  },
  beforeCreate () {
    if (localStorage.getItem('is_loggedin')) {
      this.$router.push({name: 'Tablero'})
    }
  },
  validations: {
    email: {
      required,
      email
    }
  },
  methods: {
    procesar() {
      this.loading = true
      let config = {
        headers: {
          'Accept': 'application/json'
        }
      }
      let usuario = {
        email: this.$v.email.$model,
      }
      this.axios.post('/auth/recovery/send', usuario, config)
        .then((res) => {
          this.loading = false
          Toast.fire({
            icon: 'success',
            title: res.data.message
          })
        })
        .catch((e) => {
          this.loading = false
          this.errorMessage = e.response.data.message
          this.errors = e.response.data.body?.errores ?? []
          this.limpiarErrorMessage()
        })
    },
    limpiarErrorMessage () {
      setTimeout(() => {
        this.errorMessage = ''
      }, 6000);
    },
    limpiarErrores (name) {
      delete this.errors[name]
    }
  }
}
</script>
